{$ifndef ALLPACKAGES}
{$mode objfpc}{$H+}
program fpmake;

uses {$ifdef unix}cthreads,{$endif} fpmkunit;

Var
  P : TPackage;
  T : TTarget;
begin
  With Installer do
    begin
{$endif ALLPACKAGES}

    P:=AddPackage('h68units');
    P.ShortName := 'h68';

    P.Author := 'FPC core team';
    P.License := 'LGPL with modification';
    P.HomepageURL := 'www.freepascal.org';
    P.Description := 'h68units, OS interface units for Human 68k/Sharp X68000';

{$ifdef ALLPACKAGES}
    P.Directory:=ADirectory;
{$endif ALLPACKAGES}
    P.Version:='3.3.1';
    P.SourcePath.Add('src');
    P.IncludePath.Add('src');

    P.OSes:=[human68k];

    T:=P.Targets.AddUnit('h68kdos.pas');
    with T.Dependencies do
      begin
        AddInclude('h68kdos.inc');
      end;
    T:=P.Targets.AddUnit('h68kiocs.pas');
    T:=P.Targets.AddUnit('h68kutil.pas');

    P.ExamplePath.Add('examples');
    T:=P.Targets.AddExampleProgram('gradient.pas');

    P.Sources.AddDoc('README.md');

{$ifndef ALLPACKAGES}
    Run;
    end;
end.
{$endif ALLPACKAGES}
